import javax.swing.event.*;
import java.awt.event.*;

public class AngleListener implements FocusListener, DocumentListener, ActionListener{
	AnglePanel lp;
	boolean[] focused;
	double[] d;
	double m;
	int length;
	double[] keisu ={1, 57.2958, 3437.75, 206265, 63.662, 0.159155};
	
	AngleListener(AnglePanel lp){ //Construstor
		this.lp = lp;
		length = lp.unitText.length;
		d = new double[length];
		focused = new boolean[length];
		for (int i = 0; i < length; i++){
			focused[i] = false;
		}
	}
	
	public void focusGained(FocusEvent e){
		Object obj = e.getSource();
		if(obj == lp.unitText[0]){
			focused[0] = true;
			} else if(obj == lp.unitText[1]){
			focused[1] = true;
			} else if(obj == lp.unitText[2]){
			focused[2] = true;
			} else if(obj == lp.unitText[3]){
			focused[3] = true;
			} else if(obj == lp.unitText[4]){
			focused[4] = true;
			} else if(obj == lp.unitText[5]){
			focused[5] = true;
		}
	}
	
	public void focusLost(FocusEvent e){
		Object obj = e.getSource();
		if(obj == lp.unitText[0]){
			focused[0] = false;
			} else if(obj == lp.unitText[1]){
			focused[1] = false;
			} else if(obj == lp.unitText[2]){
			focused[2] = false;
			} else if(obj == lp.unitText[3]){
			focused[3] = false;
			} else if(obj == lp.unitText[4]){
			focused[4] = false;
			} else if(obj == lp.unitText[5]){
			focused[5] = false;
		}
	}
	
	public void insertUpdate(DocumentEvent e){
//		Object obj = e.getSource();

		if(e.getDocument() == lp.unitText[0].getDocument() && focused[0]){
			toBaseUnit(0, getUnitText(0));
			setEachUnit();
		} else if(e.getDocument() == lp.unitText[1].getDocument() && focused[1]){
			toBaseUnit(1, getUnitText(1));
			setEachUnit();
		} else if(e.getDocument() == lp.unitText[2].getDocument() && focused[2]){
			toBaseUnit(2, getUnitText(2));
			setEachUnit();
		} else if(e.getDocument() == lp.unitText[3].getDocument() && focused[3]){
			toBaseUnit(3, getUnitText(3));
			setEachUnit();
		} else if(e.getDocument() == lp.unitText[4].getDocument() && focused[4]){
			toBaseUnit(4, getUnitText(4));
			setEachUnit();
		} else if(e.getDocument() == lp.unitText[5].getDocument() && focused[5]){
			toBaseUnit(5, getUnitText(5));
			setEachUnit();
		}
	}

	public void removeUpdate(DocumentEvent e){
		insertUpdate(e);
	}
	
	public void changedUpdate(DocumentEvent e){
		
	}

	public void actionPerformed(ActionEvent e){
		clearText();
	}
	
	
	public void setEachUnit(){
		for(int i = 0; i < length; i++){
			d[i] = m * keisu[i];
		}
		
		for(int i = 0; i < length; i++){
			if(!focused[i])
			lp.unitText[i].setText(Double.toString(d[i]));
		}
	}
	
	public double getUnitText(int num){
		double d;
		try{
			d = Double.parseDouble(lp.unitText[num].getText());
		}catch (NumberFormatException error){ d = 0.0; }
		return d;
	}
	
	public void clearText(){
		for(int i = 0; i < length; i++){
			if(!focused[i])
			lp.unitText[i].setText("");
		}
	}
	
	public void toBaseUnit(int num, double a){
		
		switch(num){
			case 0:
			m = a / keisu[0];
			break;
			
			case 1:
			m = a / keisu[1];
			break;
			
			case 2:
			m = a / keisu[2];
			break;
			
			case 3:
			m = a / keisu[3];
			break;
			
			case 4:
			m = a / keisu[4];
			break;
			
			case 5:
			m = a / keisu[5];
			break;
		}
	}
}